/* <!-- START LICENSE -->


Program Ini Di buat Oleh DEVELOPER Dari PERUSAHAAN GLOBAL CORPORATION 
Social Media: 

- Youtube: https://youtube.com/@Global_Corporation 
- Github: https://github.com/globalcorporation
- TELEGRAM: https://t.me/GLOBAL_CORP_ORG_BOT

Seluruh kode disini di buat 100% murni tanpa jiplak / mencuri kode lain jika ada akan ada link komment di baris code

Jika anda mau mengedit pastikan kredit ini tidak di hapus / di ganti!

Jika Program ini milik anda dari hasil beli jasa developer di (Global Corporation / apapun itu dari turunan itu jika ada kesalahan / bug / ingin update segera lapor ke sub)

Misal anda beli Beli source code di Slebew CORPORATION anda lapor dahulu di slebew jangan lapor di GLOBAL CORPORATION!


<!-- END LICENSE --> */
// ignore_for_file: non_constant_identifier_names

import 'dart:convert';

import 'package:general_lib/extension/list.dart';
import 'package:general_lib/file_system_entity/sort_entity_type.dart';
import 'package:universal_io/io.dart';

extension ExtensionOnStorTtpe on List<FileSystemEntity> {
  List<FileSystemEntity> local_sort({
    SortFileSystemEntityType sortFileSystemEntityType = SortFileSystemEntityType.type,
  }) {
    switch (sortFileSystemEntityType) {
      case SortFileSystemEntityType.name:
        sort((a, b) => a.path.compareTo(b.path));
        break;
      case SortFileSystemEntityType.size:
        sort((a, b) => a.statSync().size.compareTo(b.statSync().size));
        break;
      case SortFileSystemEntityType.time:
        sort((a, b) => a.statSync().modified.compareTo(b.statSync().modified));
        break;
      case SortFileSystemEntityType.type:
        sort((a, b) {
          if (a is Directory && b is Directory) {
            return a.path.toLowerCase().compareTo(b.path.toLowerCase());
          } else if (a is Directory) {
            return -1;
          } else if (b is Directory) {
            return 1;
          } else {
            // Memisahkan file normal dan hidden file
            final isHiddenA = a.path.startsWith('.');
            final isHiddenB = b.path.startsWith('.');

            if (isHiddenA && isHiddenB) {
              return a.path.toLowerCase().compareTo(b.path.toLowerCase());
            } else if (isHiddenA) {
              return 1;
            } else if (isHiddenB) {
              return -1;
            } else {
              return a.path.toLowerCase().compareTo(b.path.toLowerCase());
            }
          }
        });
        break;
    }
    return this;
  }

  List<FileSystemEntityChildren> toTree() {
    List<FileSystemEntityChildren> sles = [];

    local_sort();

    for (var i = 0; i < length; i++) {
      FileSystemEntity fileSystemEntity = this[i];
      if (fileSystemEntity is File) {
        sles.add(FileSystemEntityChildren(
          fileSystemEntity: fileSystemEntity,
          fileSystemEntityType: fileSystemEntity.statSync().type,
          children: [],
        ));
      } else if (fileSystemEntity is Directory) {
        sles.add(FileSystemEntityChildren(
          fileSystemEntity: fileSystemEntity,
          fileSystemEntityType: fileSystemEntity.statSync().type,
          children: fileSystemEntity.listSync().clone<FileSystemEntity>().local_sort().toTree(),
        ));
      } else {
        sles.add(FileSystemEntityChildren(
          fileSystemEntity: fileSystemEntity,
          fileSystemEntityType: fileSystemEntity.statSync().type,
          children: [],
        ));
      }
    }
    return sles;
  }
}

extension FileSaloslapsExtension on List<FileSystemEntityChildren> {
  List<Map> toJson() {
    return map((e) => e.toJson()).toList(
      growable: true,
    );
  }
}

class FileSystemEntityChildren {
  FileSystemEntity fileSystemEntity;
  FileSystemEntityType fileSystemEntityType;
  List<FileSystemEntityChildren> children;
  FileSystemEntityChildren({
    required this.fileSystemEntity,
    required this.fileSystemEntityType,
    required this.children,
  });

  Map toJson() {
    return {
      "@type": "fileSystemEntityChildren",
      "path": fileSystemEntity.path,
      "type": fileSystemEntityType.toString(),
      "children": children.map((e) => e.toJson()).toList(
        growable: true,
      ),
    };
  }

  @override
  String toString() {
    return json.encode(toJson());
  }
}
