/* <!-- START LICENSE -->


Program Ini Di buat Oleh DEVELOPER Dari PERUSAHAAN GLOBAL CORPORATION 
Social Media: 

- Youtube: https://youtube.com/@Global_Corporation 
- Github: https://github.com/globalcorporation
- TELEGRAM: https://t.me/GLOBAL_CORP_ORG_BOT

Seluruh kode disini di buat 100% murni tanpa jiplak / mencuri kode lain jika ada akan ada link komment di baris code

Jika anda mau mengedit pastikan kredit ini tidak di hapus / di ganti!

Jika Program ini milik anda dari hasil beli jasa developer di (Global Corporation / apapun itu dari turunan itu jika ada kesalahan / bug / ingin update segera lapor ke sub)

Misal anda beli Beli source code di Slebew CORPORATION anda lapor dahulu di slebew jangan lapor di GLOBAL CORPORATION!


<!-- END LICENSE --> */
// ignore_for_file: unnecessary_string_interpolations, unnecessary_brace_in_string_interps, non_constant_identifier_names

import 'dart:async';
import 'dart:convert';
import 'package:general_lib/dart/dart.dart';

class Log {
  Object? data;
  String title;
  String name;
  Zone? zone;
  Object? error;
  StackTrace? stackTrace;
  DateTime? dateTimeStart;
  DateTime? dateTimeNow;
  Log(
    this.data, {
    this.title = "LOG",
    this.name = "info",
    this.zone,
    this.dateTimeNow,
    this.dateTimeStart,
    this.error,
    this.stackTrace,
    bool? isPrintToTerminal = true,
  }) {
    dateTimeStart ??= DateTime.now();
    dateTimeNow ??= DateTime.now();
    if (isPrintToTerminal is bool) {
      if (isPrintToTerminal) {
        printToTerminal();
      }
    } else {
      // dart
      if (dart.isDebug) {
        printToTerminal();
      }
    }
  }

  String getAllText() {
    String msg = "${title}";
    msg += "\n[DATE TIME START]\t${dateTimeStart.toString()}";
    // }
    // if (dateTimeNow != null)
    msg += "\n[DATE TIME NOW]\t${dateTimeNow.toString()}";
    msg += "\nMessage";
    if (data is Map || data is List) {
      msg += "\n${JsonEncoder.withIndent(" " * 2).convert(data)}";
    } else {
      msg += "\n${data.toString()}";
    }
    // if (stackTrace != null) {
    msg += "\n${name.toUpperCase()}";

    List<String> error_stacks = stackTrace.toString().trim().split("\n");
    for (var i = 0; i < error_stacks.length; i++) {
      String error = error_stacks[i];
      msg += "\n[${name}]\t${error}";
    }
    // }

    return msg;
  }

  String getLongText() {
    List<String> msgs = getAllText().split("\n");

    String text = "";

    for (var i = 0; i < msgs.length; i++) {
      String msg = msgs[i];
      if (msg.length > text.length) {
        text = msg.replaceAll(RegExp(r"\t"), " ");
      }
    }

    return "${" " * 2}${text}${" " * 2}";
  }

  String line(
      {required String text, required String fill, required int longText}) {
    final fillCount = longText - text.length;
    List<String> left = List.generate(fillCount ~/ 2, (index) => fill);
    List<String> right =
        List.generate(fillCount - left.length, (index) => fill);
    // final left = List.filled(fillCount ~/ 2, fill);
    // final right = List.filled(fillCount - left.length, fill);
    return left.join() + text + right.join();
  }

  String containerFull({
    required String text,
    required int longText,
  }) {
    return "${containerTop(longText: longText)}\n${containerMid(text: text, longText: longText)}\n${containerEnd(longText: longText)}";
  }

  String containerTop({
    required int longText,
  }) {
    return "╔${line(text: '', fill: '═', longText: longText)}╗";
  }

  String containerMid({
    required String text,
    required int longText,
  }) {
    return "║${line(text: text, fill: ' ', longText: longText)}║";
  }

  String containerMidClose({
    required int longText,
  }) {
    // print('╟${line('', '─')}╢');
    return "╟${line(text: "", fill: '─', longText: longText)}╢";
  }

  String containerEnd({
    required int longText,
  }) {
    return "╚${line(text: "", fill: '═', longText: longText)}╝";
  }

  void printToTerminal() {
    print(toString());
  }

  @override
  String toString() {
    String longText = getLongText();

    String msg = containerFull(text: title, longText: longText.length);
    if (dateTimeStart != null) {
      msg += "\n[DATE TIME START]\t${dateTimeStart.toString()}";
    }
    if (dateTimeNow != null) {
      msg += "\n[DATE TIME NOW]\t${dateTimeNow.toString()}";
    }

    msg += "\n${containerFull(text: "Message", longText: longText.length)}";

    if (data is Map || data is List) {
      msg += "\n${JsonEncoder.withIndent(" " * 2).convert(data)}";
    } else {
      msg += "\n${data.toString()}";
    }
    if (stackTrace != null) {
      msg +=
          "\n${containerFull(text: name.toUpperCase(), longText: longText.length)}";
      List<String> error_stacks = stackTrace.toString().trim().split("\n");
      for (var i = 0; i < error_stacks.length; i++) {
        String error = error_stacks[i];
        msg += "\n[${name}]\t${error}";
      }
    }

    msg += "\n${containerFull(text: "Complete", longText: longText.length)}";
    return msg;
  }
}
